#ifndef __DSPLIB_H__
#define __DSPLIB_H__

#include <vstypes.h>

/** Bi-quad IIR coefficients. */
struct DSP_IIR2COEFF16 {
    s_int16 b0,b1,b2,a1,a2;
};

/** Calculates bi-quad IIR for one sample. 26 cycles.
 */
__near auto s_int32 DspIir2Lq(register __a0 s_int16 val,
			      register __i0 __near const __mem_y struct DSP_IIR2COEFF16 *baCoeff,
			      register __i2 __near s_int16 mem[5]);
/** Calculates bi-quad IIR for a block of samples. 27+10*n cycles.
 */
__near auto void DspIir2nLq(register __i1 __near s_int16 *buffer,
			    register __i0 __near const __mem_y struct DSP_IIR2COEFF16 *baCoeff,
			    register __i2 __near s_int16 mem[5], register __a1 s_int16 n);

/** Calculates 64-bit multiplication result. 12 cycles.
 */
auto void Mul64(register __reg_a s_int32 a, register __reg_d s_int32 d,
		register __i0 s_int32 reslohi[2]);

/** Calculates sine from phase.
    \param phase - fractional value, range [-1.0 1.0) is [-180 180) degrees
    \return value in range of [-1.0 1.0)
 */
s_int32 frsine32(register __reg_c s_int32 phase);

#endif /* !__DSPLIB_H__ */
